import java.util.*;
import java.io.IOException;
import java.io.DataInputStream;
import java.io.ByteArrayInputStream;
import com.siemens.mp.io.*;
import javax.microedition.lcdui.TextField;

public class Dictionary {
  File myFile=null;
  SiemensFileInputStream indexStream=null;
  DataInputStream dIndexStream=null;
  SiemensFileInputStream keyStream=null;
  DataInputStream dKeyStream=null;
  SiemensFileInputStream dictStream=null;
  DataInputStream dDictStream=null;
  Hashtable inputMap;
  Hashtable outputMap;
  Random rndGen;

  private int dictionaryKeySize;


public Dictionary(String indexFile,String keyFile,String dictFile,Hashtable inputMap,Hashtable outputMap) {
  try {
    myFile=new File();
    indexStream=new SiemensFileInputStream(indexFile,myFile);
    dIndexStream=new DataInputStream(indexStream);
    keyStream=new SiemensFileInputStream(keyFile,myFile);
    dKeyStream=new DataInputStream(keyStream);
    dictStream=new SiemensFileInputStream(dictFile,myFile);
    dDictStream=new DataInputStream(dictStream);

    this.inputMap=inputMap;
    this.outputMap=outputMap;
    this.dictionaryKeySize=myFile.length(indexStream.fileDesc)/4;
    rndGen=new Random();
  } catch (java.io.IOException ioe) { System.out.println(ioe);System.exit(1); }
}

public Dictionary(String indexFile,String keyFile,String dictFile,String inputMapFile,String outputMapFile) {

}

/*
public void close() {
  try {
    indexStream.close();
    dIndexStream.close();
    keyStream.close();
    dKeyStream.close();
    dictStream.close();
    dDictStream.close();
  } catch (java.io.IOException ioe) { System.out.println(ioe);System.exit(1); }
}
*/
public String translateInput(String inputString) {
  return inputString;
}

public String translateOutput(String outputString) {
 Character myKey;
 Character myValue;
 System.out.println("Replacing the list of keys with values");

 for (Enumeration e = outputMap.keys(); e.hasMoreElements();)
  {
		myKey=(Character) e.nextElement();
    myValue=(Character) outputMap.get(myKey);
    System.out.println("replacing " + myKey + " with " + myValue + " for string " + outputString);
    outputString=outputString.replace(myKey.charValue(),myValue.charValue());
    // hey yavrum hey , character conversion olayna bile madik attk :)
  }
  return outputString;
}

public String getResult(int position) {
 return "al sana result";
}

public Vector search(String searchKey,TextField reveal){
  boolean found=false;
  int nodePointer;
  int fileLength;
  byte nodeHeader[]={0,0};
  byte nodePointerBuffer[]={0,0,0,0};
  int nodePointerV=0;
  int nodePointerVB;
  int compareVal;
  byte nodeKey[];
  boolean outLoop=false;
  int cc=0;
  int indexNode;
  int oldIndexNode;
  int skipBytes;
  int bytesRead=0;
  String s=null;

  indexNode=1;

  try {
  myFile.seek(indexStream.fileDesc,0);
    while (!outLoop) {
      cc++;
      nodePointerV=dIndexStream.readInt();
      myFile.seek(keyStream.fileDesc,nodePointerV); // seek operation
      myFile.read(keyStream.fileDesc,nodeHeader,0,2);
      nodeKey=new byte[(int) nodeHeader[0]];bytesRead+=(int) nodeHeader[0];
      myFile.read(keyStream.fileDesc,nodeKey,0,nodeKey.length);
      s=new String(nodeKey);
      reveal.setString(s);
      System.out.println("key is " + s);
      compareVal=searchKey.compareTo(s);

      if (cc>20) { outLoop=true;}

      if (compareVal>0) {
        oldIndexNode=indexNode;
        indexNode=indexNode*2+1;
        //System.out.println("right seeking to " + (indexNode*4-4) + " in indexStream");
        myFile.seek(indexStream.fileDesc,indexNode*4-4); // seek operation
        // go right
      } else if (compareVal!=0) {// go left if not equal
        // go left
        oldIndexNode=indexNode;
        indexNode=indexNode*2;
        //System.out.println("left seeking to " + (indexNode*4-4) + " in indexStream");
        myFile.seek(indexStream.fileDesc,indexNode*4-4);
        } else {
        // we found the item
        //System.out.println("found");
        found=true;
        outLoop=true;
        // find the items that are prefixed with the one found



        }

      }

      // } catch ( EOFException e) { found=false; }


  if (found) {
    byte strBuf[]=new byte[500];
    Vector a=new Vector();
    int seekPoint;
    System.out.println("will iterate the list");
    for (int kk=0;kk<nodeHeader[1];kk++)
      {
      seekPoint=dKeyStream.readInt();
      //System.out.println("\nline at location : " + seekPoint);
      myFile.seek(dictStream.fileDesc,seekPoint);
      System.out.println("reading line bytes");
      int k=dictStream.readLineBytes(strBuf);
      System.out.println("Actual length=" + k);
      System.out.println("line bytes read");
      //a.addElement(new String(strBuf));
      // a.addElement(new Integer(seekPoint));
      a.addElement(new SearchResult(seekPoint,s,this.translateOutput(new String(strBuf)),""));
      }
      return a;
  }  else {
    return null;
  }

 } catch ( IOException e) { e.printStackTrace();System.out.println("error during file operation");found=false; }

return null;

 }




public SearchResult getRandomKeyResult() {
  int nodePointerV;
  byte nodeHeader[]={0,0};
  String s;
  byte nodeKey[];
  int rndPoint;

  rndPoint=rndGen.nextInt() % (dictionaryKeySize);
  if (rndPoint<0) rndPoint=0-rndPoint;
  System.out.println("rnd point is:" + rndPoint);
  System.out.println("key size is:" + dictionaryKeySize);

  try {
    myFile.seek(indexStream.fileDesc,rndPoint*4);
    nodePointerV=dIndexStream.readInt();

    myFile.seek(keyStream.fileDesc,nodePointerV); // seek operation
    myFile.read(keyStream.fileDesc,nodeHeader,0,2);
    nodeKey=new byte[(int) nodeHeader[0]];
    myFile.read(keyStream.fileDesc,nodeKey,0,nodeKey.length);
    s=new String(nodeKey);



    byte strBuf[]=new byte[100];
    int seekPoint;
    seekPoint=dKeyStream.readInt();
    myFile.seek(dictStream.fileDesc,seekPoint);
    System.out.println("reading line bytes");
    dictStream.readLineBytes(strBuf);
    System.out.println("line bytes read");

    return new SearchResult(nodePointerV,s,"",this.translateOutput(new String(strBuf)));
  } catch ( IOException e) { e.printStackTrace();System.out.println("error during file operation");return null; }
}


}


