import java.util.*;
import com.siemens.mp.io.*;
import java.io.IOException;
import java.io.DataInputStream;

public class DictionaryConfigReader {

  public static Vector readDictionaryConfigurations(String configFile) {
    char cLF=0x0a;
    SiemensFileInputStream sfis=null;
    DataInputStream dsfis=null;
    File myFile=new File();
    Vector dictionaryConfigs=null;
    StringBuffer lineInput=null;
    try {
      sfis=new SiemensFileInputStream(configFile,myFile);
      dsfis=new DataInputStream(sfis);

      // fuck the declarative style for the configuration file
      // i'll collect the config data from "," separated fields
      // in each line of input.
      // that's the easiest way.
      dictionaryConfigs=new Vector();
      while (true) {
      lineInput=new StringBuffer("");
      char charInput=(char) dsfis.readByte();
        while (charInput!=cLF) {
          lineInput.append(charInput);
          charInput=(char) dsfis.readByte();
          // System.out.println("Char read is : " + charInput);
        }
      // here we will be parsing the line of input
      // System.out.println("line read :)");
      // System.out.println("LineInput is : " + lineInput);
      String lineStr=new String(lineInput);
      lineStr.trim();
      dictionaryConfigs.addElement(parseLine(lineStr));
      }

    } catch (java.io.IOException ioe) {System.out.println(ioe);}
   // System.out.println("LineInput is : " + lineInput);
  return dictionaryConfigs;
  }



  /*
  // old parseLine
  static Hashtable parseLine(String lineStr) {
    Hashtable h=new Hashtable();
    StringTokenizer s=new StringTokenizer(lineStr,",");
    h.put(new String("name"), s.nextToken().trim());
    //System.out.println(h.get("name"));
    h.put(new String("idx"), s.nextToken().trim());
    //System.out.println(h.get("idx"));
    h.put(new String("key"), s.nextToken().trim());
    //System.out.println(h.get("key"));
    h.put(new String("dict"), s.nextToken().trim());
    //System.out.println(h.get("dict"));
    h.put(new String("map"), s.nextToken().trim());
    //System.out.println(h.get("map"));
    System.out.println(h);
    return h;
  }
  */

  //
  // we have  three records separated by pipe character
  // then each record is divided by comma
  // first is the dictionary files , second input mappings
  // third output mappings.

  static Hashtable parseLine(String lineStr) {
    Hashtable h=new Hashtable();
    StringTokenizer sParts=new StringTokenizer(lineStr,"|");
    StringTokenizer sFiles=new StringTokenizer(sParts.nextToken().trim(),",");

    //--------- Parse the filenames -------------------
    h.put(new String("name"), sFiles.nextToken().trim());
    //System.out.println(h.get("name"));
    h.put(new String("idx"), sFiles.nextToken().trim());
    //System.out.println(h.get("idx"));
    h.put(new String("key"), sFiles.nextToken().trim());
    //System.out.println(h.get("key"));
    h.put(new String("dict"), sFiles.nextToken().trim());
    //System.out.println(h.get("dict"));
    System.out.println(h);

    //--------- Parsing of Mapping--------------------------
    String s1,s2;
    //--------- Parse the input mappings -------------------
    String inputStr=sParts.nextToken();
    if (inputStr!=null) {
      StringTokenizer sInput=new StringTokenizer(inputStr.trim(),",");
      Hashtable inputMap=new Hashtable();
      s1=sInput.nextToken();
      s2=sInput.nextToken();
      while (s1!=null) {
        inputMap.put(new Character((char)Integer.parseInt(s1,16)),new Character( (char)Integer.parseInt(s2,16)));
        System.out.println("mapping input " + s1 + " to " +s2);
        s1=sInput.nextToken();
        s2=sInput.nextToken();
      }
      h.put(new String("inputmap"),inputMap);
    }

    //--------- Parse the output mappings -------------------
    String outputStr=sParts.nextToken();
    if (outputStr!=null) {
      StringTokenizer sOutput=new StringTokenizer(outputStr.trim(),",");
      Hashtable outputMap=new Hashtable();
      s1=sOutput.nextToken();
      s2=sOutput.nextToken();
      while (s1!=null) {
        Character c1,c2;
        outputMap.put(new Character((char)Integer.parseInt(s1,16)),new Character( (char)Integer.parseInt(s2,16)));        // outputMap.put(s1,s2);
        System.out.println("mapping output " + s1 + " to " +s2);
        s1=sOutput.nextToken();
        s2=sOutput.nextToken();
      }
      h.put(new String("outputmap"),outputMap);
    }
    return h;
  }

}
