import javax.microedition.lcdui.*;
import java.io.*;
import java.util.*;

class EnglishEntry extends Form implements CommandListener, Backable
{
  private final TextField romajistr = (new TextField("", "", 50, TextField.ANY));
  private final StringItem finalstr = new StringItem("", "");
  private static final Command cmdBack = new Command(Localizer.getMessageItem("bck"), Command.BACK, 1);
  private static final Command cmdSend = new Command(Localizer.getMessageItem("lookup"), Command.OK, 0);
  private Hashtable dictionaryConfig;
  private Backable introCanvas;
  private Display display;
  private SearchResults sr;


  public EnglishEntry()
  {
    super("Ingilizce - Turkce");
    //   display = Display.getDisplay(this);
    byte imageBytes[]={77,66,99,123,54,34,44,55};
    append(romajistr);
    append(finalstr);
    System.out.println("romaji str appended");

    addCommand(cmdBack);
    addCommand(cmdSend);
    setCommandListener(this);
    System.out.println("English entry init");
  }

  public void shows(Display disp, Backable go_back)
  {
    display = disp;
    introCanvas = go_back;
    shows();
  }

  public void shows()
  {
    display.setCurrent(this);
    setCommandListener(this);
    this.setTitle((String) dictionaryConfig.get("name"));
  }

  public void setDictionaryConfig(Hashtable dictConfig) {
    Dictionary d;
    System.out.println("getting dicitonary object");
    try {
      d=(Dictionary) dictionaryConfig.get("dictionary");
      System.out.println("got dictionary object");
      System.out.println("previous dictionary exists");
      //d.close();
      dictionaryConfig=dictConfig;
    }
    catch (NullPointerException npe) {
      System.out.println("no previous dictionary");
      dictionaryConfig=dictConfig;
    }

  }

  public void commandAction(Command command, Displayable displayable)
  {
    String label = command.getLabel();

   if (command == cmdBack)
   {
     // introCanvas.shows(display,this); killing back stuff
     introCanvas.shows();
   }

   if (command == cmdSend)
   {
     String romaji=romajistr.getString();
     String finalstrtext="";
     System.out.println("Trying to search");
     Dictionary d=(Dictionary) this.dictionaryConfig.get("dictionary");
     Vector v=d.search(romaji,romajistr);
     System.out.println("Returned from search function");
     sr=new SearchResults(v,d);
     sr.shows(display,this);
     /*
     if (v!=null) {
      System.out.println("found it");
       for (int kk=0;kk<v.size();kk++)
        {
          finalstrtext=finalstrtext + v.elementAt(kk) + "\n";
        }
       finalstr.setText(finalstrtext);
       System.gc();
     } else {
      System.out.println("Can't find");
     }
     // EntryForm myEntryForm=new EntryForm(romaji);
     // myEntryForm.shows(display,this);
     */
   } //command

 } // method

} //class