import java.util.Vector;
import java.util.Hashtable;
import javax.microedition.rms.*;
import java.io.*;

public class Localizer {
static final String languageList[]={"Turkce","Soparca","English","Deutsch","Nihongo","Romanized Nihongo"};
static final String languageIdentifiers[]={"tr","str","en","de","jp","rjp"};
static String currentLanguage="tr";
static Hashtable messages;
static String RSname="Options";
static RecordStore recordopts = null;
static byte langOptData[];
static int langOptId=1;


static {
  messages=new Hashtable();
  /* trke */
  messages.put("tr-lookup","Ara");
  messages.put("tr-exit","Programdan Cik");
  messages.put("tr-dicts","Szlkler");
  messages.put("tr-sel","Se");
  messages.put("tr-opt","Seenek");
  messages.put("tr-bck","Geri");
  messages.put("tr-prc","Pratik");
  messages.put("tr-use","Kullan");
  messages.put("tr-show","Gster");
  messages.put("tr-results","Sonuclar");
  messages.put("tr-result","Sonuc");
  messages.put("tr-next","Sonraki");
  messages.put("tr-save","Kaydet");
  messages.put("tr-langchoice","Dil seenekleri");
  messages.put("tr-restart","Degisikligin gecerli olmasi icin programi yeniden baslatin");
  messages.put("tr-about","Program hakkinda");


  /* ingilizce */
  messages.put("str-lookup","Bak");
  messages.put("str-exit","Cikcanmi");
  messages.put("str-dicts","Te be szlkler");
  messages.put("str-sel","Se be yav");
  messages.put("str-opt","Seesin");
  messages.put("str-bck","Ayda geri");
  messages.put("str-prc","Idman");
  messages.put("str-use","Kullan be");
  messages.put("str-show","Gster be");
  messages.put("str-results","Cikti bunlar");
  messages.put("str-result","Iste aha");
  messages.put("str-next","Devam");
  messages.put("str-save","Kaydet");
  messages.put("str-langchoice","Se bi dil be yav");
  messages.put("str-restart","Baslat programi yeniden be");
  messages.put("str-about","Program akkinda");


  /* ingilizce */
  messages.put("en-lookup","Search");
  messages.put("en-exit","Exit");
  messages.put("en-dicts","Dictionaries");
  messages.put("en-sel","Select");
  messages.put("en-opt","Options");
  messages.put("en-bck","Back");
  messages.put("en-prc","Practice");
  messages.put("en-use","Use");
  messages.put("en-show","Show");
  messages.put("en-results","Results");
  messages.put("en-result","Result");
  messages.put("en-next","Next");
  messages.put("en-save","Save");
  messages.put("en-langchoice","Languages");
  messages.put("en-restart","Restart for change to take effect");
  messages.put("en-about","About program");

  /* japonca */
  messages.put("jp-lookup","\u8F9E\u66F8\u30EA\u30B9\u30C8");
  messages.put("jp-exit","\u51FA\u308B");
  messages.put("jp-dicts","\u8F9E\u66F8\u30EA\u30B9\u30C8");
  messages.put("jp-sel","\u64B0\u3076");
  messages.put("jp-opt","\u30AA\u30D7\u30B7\u30E7\u30F3");
  messages.put("jp-bck","\u8FD4\u308B");
  messages.put("jp-prc","\u7A3D\u53E4");
  messages.put("jp-use","\u4F7F\u3046");
  messages.put("jp-show","\u898B\u305B\u308B");
  messages.put("jp-results","\u30EA\u30B6\u30EB\u30C8");
  messages.put("jp-result","\u30EA\u30B6\u30EB\u30C8");
  messages.put("jp-next","\u6B21");
  messages.put("jp-save","\u30BB\u30FC\u30D6");
  messages.put("jp-langchoice","\u8A9E\u66F8\u30EA\u30B9\u30C8");
  messages.put("jp-restart","\u30EA\u30B9\u30BF\u30FC\u30C8\u3000\u4E0B\u3055\u3044");
  messages.put("jp-about","About");
}


public static int getCurrentLanguageIndex() {
  for (int i=0;i<languageIdentifiers.length;i++) {
    if (currentLanguage.equals(languageIdentifiers[i]))  {
      return i;
    }
  }
  return 0;
}

public static void setCurrentLanguage(String language) {
  try {
  // ByteArrayOutputStream langOptStream = new ByteArrayOutputStream();
  //DataOutputStream langOptOut = new DataOutputStream(langOptStream);
  //langOptOut.writeBoolean(true);
	//langOptOut.writeUTF(language);
  // langOptData = langOptStream.toByteArray();
  langOptData=language.getBytes();
  }
  catch (Exception ioe) {System.out.println("char conversion failure"); }


  try {
    recordopts = RecordStore.openRecordStore(RSname, true);
  }
  catch(RecordStoreException exception)
  {
    System.out.println("RecordStoreNotFoundException");
  }

  try {
    if (recordopts.getNumRecords() == 0) {
        System.out.println("Creating the first record");
        System.out.println("it has " + langOptData.length + " bytes");
        langOptId = recordopts.addRecord(langOptData, 0, langOptData.length);
    }
    else
    {
        System.out.println("Updating the record");
        /*
        try {
          recordopts.closeRecordStore();
          }
            catch(RecordStoreException exception)
            {
            System.out.println("RCException" + exception);
            }
        RecordStore.deleteRecordStore(RSname);
        System.out.println("Deleted");
        recordopts = RecordStore.openRecordStore(RSname, true);
        System.out.println("Opened");
        langOptId = recordopts.addRecord(langOptData, 0, langOptData.length);
        System.out.println("Added");
        */
        recordopts.setRecord(langOptId,langOptData,0,langOptData.length);
    }
  }
  catch(RecordStoreException exception)
  {
    System.out.println("RCException" + exception);
  }
Localizer.currentLanguage=language;
}


public static void setCurrentLanguage() {
  Localizer.currentLanguage=Localizer.getCurrentLanguage();
}

public static String getCurrentLanguage() {

  try {
    recordopts = RecordStore.openRecordStore(RSname, false);

    if (recordopts.getNumRecords() == 0) {
      return currentLanguage;
    }
    else
    {
      try {
        System.out.println("lang id :" + langOptId);
        langOptData=recordopts.getRecord(langOptId);
        System.out.println(langOptData.length);
          for (int ii=0;ii<langOptData.length;ii++) System.out.println(langOptData[ii]);
        return new String(langOptData);
        }
      catch (Exception e)
        {
        System.out.println(e);
        System.out.println("Returning default");
        return currentLanguage;
        }
    }
  } catch(RecordStoreException rse) {System.out.println("exception when reading config");return currentLanguage;}

}


public static String getMessageItem(String language,String mKeyword) {
 return (String) messages.get(language + "-" + mKeyword);
}

public static String getMessageItem(String mKeyword) {
 System.out.println("keyword is :" + mKeyword);
 System.out.println("lang is :" + Localizer.currentLanguage); 
 return (String) messages.get(Localizer.currentLanguage + "-" + mKeyword);
}

/*
static Vector getLanguageList() {

} */

public static void main(String args[]) {
  Localizer.setCurrentLanguage("en");
  System.out.println(Localizer.getMessageItem("dicts"));
}



}